| [Home](/trick) → Documentation Home |
|------------------------------------|

# User Guide
The user guide contains information pertinent to Trick users. These pages will help you create Trick simulations and understand how certain aspects of Trick function. 

01. [Introduction](introduction/Introduction)

01. [Trick Install Guide](install_guide/Install-Guide)

01. [Building a Simulation](building_a_simulation/Building-a-Simulation)
    01. [Model Source Code](building_a_simulation/Model-Source-Code)
    01. [Environment Variables](building_a_simulation/Environment-Variables)
    01. [Simulation Definition File (S_define)](building_a_simulation/Simulation-Definition-File)
    01. [Making the Simulation](building_a_simulation/Making-the-Simulation)
    01. [Trickified Project Libraries](building_a_simulation/Trickified-Project-Libraries)

01. [Running a Simulation](running_a_simulation/Running-a-Simulation)
    01. [Input File](running_a_simulation/Input-File)
    01. [Runtime GUIs](running_a_simulation/runtime_guis/Runtime-GUIs)
    01. [Runtime Output](running_a_simulation/Runtime-Output)

01. [Data Products (DP)](data_products/Data-Products)
    01. [DP Session File Format](data_products/DP-Session-File-Format)
    01. [DP Product File Format](data_products/DP-Product-File-Format)
    01. [Plot Printing](data_products/Plot-Printing)
    01. [Data Products GUIs](data_products/Data-Products-GUIs)
 
01. [Simulation Capabilities](simulation_capabilities/Simulation-Capabilities)  
    01. [Executive Scheduler](simulation_capabilities/Executive-Scheduler)  
    01. [Input Processor](simulation_capabilities/Input-Processor)  
    01. [Just in Time C++ Input Processor](simulation_capabilities/JIT-Input-Processor)  
    01. [Event Manager](simulation_capabilities/Event-Manager)  
    01. [Realtime](simulation_capabilities/Realtime)
    01. [Realtime Clock](simulation_capabilities/Realtime-Clock)  
    01. [Realtime Sleep Timer](simulation_capabilities/Realtime-Timer)  
    01. [Realtime Injector](simulation_capabilities/Realtime-Injector)  
    01. [Monte Carlo](simulation_capabilities/UserGuide-Monte-Carlo)
    01. [Master Slave](simulation_capabilities/Master-Slave)  
    01. [Data Record](simulation_capabilities/Data-Record)  
    01. [Checkpoints](simulation_capabilities/Checkpoints)  
    01. [MemoryManager](simulation_capabilities/memory_manager/MemoryManager)  
    01. [Integrator](simulation_capabilities/Integrator)  
    01. [Frame Logging](simulation_capabilities/Frame-Logging)  
    01. [Debug Pause](simulation_capabilities/Debug-Pause)  
    01. [Echo Jobs](simulation_capabilities/Echo-Jobs)  
    01. [Variable Server](simulation_capabilities/Variable-Server)  
    01. [Status Message System](simulation_capabilities/Status-Message-System)  
    01. [Command Line Arguments](simulation_capabilities/Command-Line-Arguments)  
    01. [Environment](simulation_capabilities/Environment)  
    01. [Standard Template Library Checkpointing](simulation_capabilities/STL-Checkpointing) 
    01. [Threads](simulation_capabilities/Threads)

01. [Web Server](web/Webserver)
    01. [Configure Trick with Civetweb](web/Configure-Civetweb)
    01. [Add SSL encryption to your webserver](web/SSL)
    01. [Web Server APIs](web/Webserver-apis)
        01. [HTTP alloc API](web/http-alloc-api.md)
        01. [WS Variable Server API](web/ws-variable-server-api.md)
        01. [Extend the HTTP API](web/Extend-http-api.md)
        01. [Extend the WS API](web/Extend-ws-api.md)

01. [Simulation Utilities](simulation_utilities/Simulation-Utilities)  
    01. [Trickcomm](simulation_utilities/Trickcomm)  
    01. [Math Utilities](simulation_utilities/Math-Utilities)   

01. [Miscellaneous Trick Tools](miscellaneous_trick_tools/Miscellaneous-Trick-Tools)  
    01. [Python Variable Server Client](miscellaneous_trick_tools/Python-Variable-Server-Client)
    02. [TrickOps Sim Testing Framework](miscellaneous_trick_tools/TrickOps.md)
 
01. [Software Requirements Specification](software_requirements_specification/SRS)
